// http://www3.cs.stonybrook.edu/~shhan/cse328/hw_two/glut_3d_rotation.cc

#include <stdio.h>
#include <GL/glut.h>

/* global variables */
static int win(0); // GLUT window ID
static int win_width(600), win_height(600); // window's width and height
static float mouse_x(0.0), mouse_y(0.0);
static float rotation_x(0.0),rotation_y(0.0);

void Mouse(int button, int state, int x, int y)
{
    if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN){
        mouse_x = (float) x;
        mouse_y = (float) y;
    }
}

// Call-back function glutMouseFunc();
void MouseMotion(int x, int y)
{
    rotation_x += (float) x - mouse_x;
    rotation_y += (float) y - mouse_y;

    mouse_x = (float) x;
    mouse_y = (float) y;

    glutPostRedisplay(); // for redraw the current mouse position;
};

// Call-back function for windows size changed;
void WindowSizeReShape(int w, int h)
{
    win_width = w;
    win_height = h;

    //update the viewport;
    glViewport(0,0,(GLsizei)w,(GLsizei)h);

    //update the projection matrix;
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(60.0,(float)win_width/win_height,0.01,50);
	gluLookAt(5.0,5.0,5.0, //eye
              0.0,0.0,0.0, //center
              0.0,1.0,0.0); //upY

    glMatrixMode(GL_MODELVIEW);
}

/* display */
void Display(void)
{
    //clean the scene
    glClearColor(0.3,0.3,0.3,1.0); //set background
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
    
    //set matrix mode to GL_MODELVIEW
    glMatrixMode(GL_MODELVIEW);
    
    glColor3f(1.0f,0.4f,0.0f);

    glPushMatrix();
    glLoadIdentity();
    glRotatef(rotation_x,0.0,1.0,0.0);
    glRotatef(rotation_y,1.0,0.0,0.0);
    glScalef(1.0f,1.0f,1.0f);
    glutWireTeapot(2.0);

    glPopMatrix();

    glutSwapBuffers();
};

/* MAIN */
int main(int argc, char* argv[])
{
    //step 1. initialize GLUT
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA|GLUT_DOUBLE);
    glutInitWindowSize(win_width,win_height);
    glutInitWindowPosition(100,100);

    //step 2. Open a window named "GLUT DEMO"
    win = glutCreateWindow("GLUT Mouse Motion");

    //misc
    glutSetCursor(GLUT_CURSOR_CROSSHAIR);

    //step 3. register the display function
    glutDisplayFunc(Display);
    glutMouseFunc(Mouse);
    glutMotionFunc(MouseMotion);
    glutReshapeFunc(WindowSizeReShape);

    //step 4, initialization of opengl statues
    glEnable(GL_DEPTH_TEST);
 
    //step 5. enter the event processing loop
    glutMainLoop();
}